var umylist={
	mylistId:false,//マイリスト名先頭にID追加
	AutoLoadOffichalMylist:false,//trueでロード時に公式マイリストを自動で読み込む
	NotFoundThumbImgSrc:'/local/umylist/404.jpg',

	mylist:{},
	Ulist:{},
	Umylistlist:{},
	data:{},
	cache:{},
	tagDic:{},
	init:function(){
		var U=this;
		$('#state').html('読み込み中');
		umylistapi.get_json(function(json){
			umylistapi.get_mjson(function(mjson){
				umylistapi.get_cachelist(function(cjson){
					U.setVariable(json,mjson,cjson);
				});
			});
		});
	},
	setVariable:function(json,mjson,cjson){
		var U=this;
		for(var i=0;i<json.length;i++){
			var D=[],movies=json[i].movies;
			for(var j=0;j<movies.length;j++){
				D.push({"id":json[i].id,"tid":movies[j].threadid,"mid":movies[j].movieid});
			}
			U.Ulist[json[i].id]={"name":json[i].name,"moviecount":D.length,"movies":D};
		}
		for(var i=0;i<mjson.length;i++){
			U.Umylistlist[mjson[i].mylistid]={"id":mjson[i].id,"name":mjson[i].name};
		}
		U.cache=cjson;
		U.data=U.parse(NCnl.getSt('NicoVideoData'));
		U.removeStorage();
		for(var a in U.data){
			var tgs=U.data[a].tags
			if(!tgs)continue;
			for(var b=0; b<tgs.length; b++){
				if(tgs[b].dic==true)U.tagDic[tgs[b].tag]=true;
			}
		}
		U.listSet();
		U.mylistListSet();
		$('#state').html('');
		if(U.AutoLoadOffichalMylist)$("#officialMylistH").click();
	},
	parse:function(data){
		if(typeof data=="object"){
			for(var a in data)data[a]=this.parse(data[a]);
		}else if(typeof data=="string"&&/^\[[^\]]+\]$/.test(data)){
			data=JSON.parse(data);
		}
		return data;
	},
	removeStorage:function(){
		var U=this;
		for(var i in U.data){
			if(U.data[i].limit < new Date().getTime())delete U.data[i];
		}
	},
	listAdd:function(mid,tid,thumb,title){
		// ここは何とかしたいところ。
		if(!confirm("現時点では、登録してもこのページには反映されず、\n反映させるにはリロードさせる必要があります。\n\nそれでもよろしいですか？"))return false;
		window.open('/local/umylist/add.html'+
			'?mid='+mid+
			'&tid='+tid+
			'&thumb='+encodeURIComponent(thumb)+
			'&title='+encodeURIComponent(title),
		'add','width=500,height=360');
	},
	listRemove:function(mylist,mid,tid){
		var U=this;
		umylistapi.remove(mylist,mid,tid,function(json){
			var text=json.status;
			switch(json.status){
				case 'succeeded':
					text='['+U.data[mid].title+'] を<br />削除しました';
					for(var i=0; i<U.Ulist[mylist].moviecount; i++){
						if(U.Ulist[mylist].movies[i].tid==tid){
							U.Ulist[mylist].movies.splice(i,1);
							break;
						}
					}
					U.Ulist[mylist].moviecount=U.Ulist[mylist].moviecount-1;
					$('#'+tid).css('display','none');
					$('#l'+mylist+'len').html('('+U.Ulist[mylist].moviecount+')');
					break;
				default:
					text="失敗しました";
					break;
			}
			$('#state').html(text);
		});
	},
	listMremove:function(mylist){
		var U=this;
		umylistapi.mremove(mylist,function(json){
			var text=json.status;
			switch(json.status){
				case 'succeeded':
					text='['+U.Ulist[mylist].name+'] を<br />削除しました';
					delete U.Ulist[mylist];
					$('#list').html('');
					$('#l'+mylist).parent().parent().css('display','none');
					break;
				default:
					break;
			}
			$('#state').html(text);
		});
	},
	listRename:function(mylist,name){
		var U=this;
		umylistapi.rename(mylist,name,function(json){
			var text=json.status;
			if(text){
				switch(json.status){
					case 'succeeded':
						text='['+U.Ulist[mylist].name+'] を<br />['+name+'] に<br />リネームしました';
						$('#headerTitle').html(name);
						$('#l'+mylist).html(name);
						U.Ulist[mylist].name=name;
						break;
					default:
						break;
				}
				$('#state').html(text);
			}
		});
	},
	listMylistRemove:function(mylist){
		var U=this;
		umylistapi.mylistRemove(mylist,function(json){
			var text=json.status;
			switch(json.status){
				case 'succeeded':
					text='['+U.Umylistlist[mylist].name+'] を<br />削除しました';
					delete U.Umylistlist[mylist];
					$('#list').html('');
					$('#ml'+mylist).parent().parent().css('display','none');
					break;
				default:
					break;
			}
			$('#state').html(text);
		});
	},
	listMylistRename:function(mylist,name){
		var U=this;
		umylistapi.mylistRename(mylist,name,function(json){
			var text=json.status;
			switch(json.status){
				case 'succeeded':
					text='['+U.Umylistlist[mylist].name+'] を<br />['+name+'] に<br />リネームしました';
					$('#headerTitle').html(name);
					U.Umylistlist[mylist].name=name;
					$('#ml'+mylist).html(name);
					break;
				default:
					break;
			}
			$('#state').html(text);
		});
	},
	updateinfo:function(mylist,I){
		var U=this,id=[],list=U.Ulist[mylist],tid0,mid0,tid1=[],mid1=[],tid,mid,html='';
		$('#state').html('読み込み中');
		for(var a=0;a<list.moviecount;a++){
			id.push({"tid":list.movies[a].tid,"mid":list.movies[a].mid});
		}
		for(var b=0;b<id.length;b++){
			tid0=id[b]['tid'],mid0=id[b]['mid'];
			if(!U.data[mid0]||!U.data[mid0][tid0])tid1.push(tid0),mid1.push(mid0);
		}
		(function(func){
			if(tid1.length!=0){
				$('#state').html('video.arrayから読み込み中');
				U.setDataVA(tid1.join(','))
					.done(function(){
						(function func2(i){
							var nextfunc=(i==tid1.length-1)?func:function(){func2(i+1)};
							if(!U.data[mid1[i]]||!U.data[mid1[i]][tid1[i]]){
								$('#state').html('getthumbinfoから読み込み中');
								U.setDataTi(tid1[i],mid1[i]).done(nextfunc).fail(func);
							}else{
								nextfunc();
							}
						})(0);
					})
					.fail(function(){
						$('#state').html('getthumbinfoから読み込み中');
						(function func2(i){
							var nextfunc=(i==tid1.length-1)?func:function(){func2(i+1)};
							U.setDataTi(tid1[i],mid1[i]).done(nextfunc).fail(func);
						})(0);
					});
			}else{
				func();
			}
		})(function(){
			for(var i=0;i<id.length;i++){
				tid=id[i].tid,mid=id[i].mid;
				if(U.data[mid][tid]){
					html+=U.makeMitem(tid,mid,mylist);
				}else{
					U.data[mid]={};
					U.data[mid][tid]={"threadDef":false,"communityId":'',"channelId":''};
					html+=U.makeMitem(tid,mid,mylist);
				}
			}
			var html2=	'<select id="sort">'+
							'<option value="title_0">タイトル昇順</option>'+
							'<option value="title_1">タイトル降順</option>'+
							'<option value="date_0">投稿が新しい順</option>'+
							'<option value="date_1">投稿が古い順</option>'+
							'<option value="view_0">再生が多い順</option>'+
							'<option value="view_1">再生が少ない順</option>'+
							'<option value="comment_0">コメントが多い順</option>'+
							'<option value="comment_1">コメントが少ない順</option>'+
							'<option value="mylist_0">マイリスト登録が多い順</option>'+
							'<option value="mylist_1">マイリスト登録が少ない順</option>'+
							'<option value="sec_0">時間が長い順</option>'+
							'<option value="sec_1">時間が短い順</option>'+
						'</select>'+
						'<div id="sortButton" class="button" onclick="umylist.listSort(\''+mylist+'\',\'umylist\')">ソート</div>'+
						'<div class="button" onclick="umylist.listMremove('+mylist+')">このマイリストを削除</div>'+
						'<div class="button" onclick="umylist.listRename('+mylist+',prompt(\'新しい名前を入力してください\',\'\'))">このマイリストをリネーム</div>';
			$('#list').html('<ul>'+html+'</ul>');
			$('#headerButton').html(html2);
			$('#headerTitle').html(U.Ulist[mylist].name);
			$('.active').removeClass('active');
			$(I.parentNode.parentNode).addClass('active');
			$('#state').html('読み込み完了');
			NCnl.setSt('NicoVideoData',U.data);
		});
	},
	makeMitem:function(tid,mid,mylist){
		var D=this.data[mid],T=this.data[mid][tid],tags='',cache=this.cache,desc=D.desc,memo='';
		if(D.tags){
			for(var i=0;i<D.tags.length;i++){
				tags+=	'<span class="tagFrm">'+(!D.tags[i].lock?'':'<span class="tagLock"></span>')+
						'<a class="tag" href="http://www.nicovideo.jp/tag/'+D.tags[i].tag+'">'+D.tags[i].tag+'</a>'+
						'<a class="'+(!D.tags[i].dic?'tagDicDis':'tagDicEna')+'" href="http://dic.nicovideo.jp/a/'+D.tags[i].tag+'"></a></span>';
			}
		}else{
			tags='<span class="tagFrm"><div class="button" onclick="umylist.updateTag(\''+tid+'\',\''+mid+'\',\''+mylist+'\')">タグを取得する</div></span>';
		}
		if(typeof D.memo=="string"){
			memo='<div id="memo'+tid+'"><fieldset><legend>マイリストコメント</legend>'+D.memo+'</fieldset></div>';
		}
		if(!desc){
			desc='<div class="button" onclick="umylist.updateDesc(\''+tid+'\',\''+mid+'\',\''+mylist+'\')">説明文を取得する</div>';
		}
		var html=	'<li id="'+tid+'" class="movieItem">'+
						'<div class="movie">'+
							'<div class="info">'+
								'<div class="thumbFrm">'+
									'<div class="thumb">'+
										'<img src="'+(D.thumb||this.NotFoundThumbImgSrc)+'" class="thumbImg" />'+
										'<div class="time">'+(D.sec||'')+'</div>'+
										(cache[mid]?'<div class="cache"></div>':
										 cache[mid+'low']?'<div class="economy"></div>':'')+
										(!D.deleted?'':'<div class="deleted"></div>')+
									'</div>'+
								'</div>'+
								'<div class="movieFrm">'+
									'<div class="movieinfo">'+
										'<span class="date">投稿日:'+D.date+'</span><span class="view">再生数:'+D.view+'</span><span class="res">コメント:'+D.comment+'</span><span class="mylist">マイリスト:'+D.mylist+'</span>'+
										(T.threadDef?'':
										T.channelId?'<span class="channel_id">チャンネル:<a href="http://ch.nicovideo.jp/channel/ch'+T.channelId+'" onMouseOver="return popThumb2(\'ch'+T.channelId+'\', 0)" onMouseOut="return nd()">ch'+T.channelId+'</a>':
										 T.communityId?'<span class="community_id">コミュ:<a href="http://com.nicovideo.jp/community/co'+T.communityId+'" onMouseOver="return popThumb2(\'co'+T.communityId+'\', 0)" onMouseOut="return nd()">co'+T.communityId+'</a>':
										 '<span class="mymemory">[id:'+tid+']</span>')+
									'</div>'+
									'<div class="title"><a href="http://www.nicovideo.jp/watch/'+(T.threadDef?mid:tid)+'"'+
	//								' onMouseOver="return popThumb2(\''+(D.threadDef?D.id:D.threadId)+'\', 0)" onMouseOut="return nd()"'+
									'>'+(D.title||mid)+'</a></div>'+
									'<div class="tags">'+tags+'</div>'+
								'</div>'+
							'</div>'+
							'<div class="desc">'+desc+'</div>'+
							memo+
						'</div>'+
						(mylist?'<div class="button"" onclick="umylist.listRemove('+mylist+',\''+mid+'\',\''+tid+'\')">削除</div>':'')+
					'</li>';
		return html;
	},
	updateTag:function(tid,mid,mylist){
		var U=this,tags=[];
		(function(func){
			umylistapi.getThumbinfo(tid).fail(func).done(function(xml){
				if($(xml).find("title").length){
					if($(xml).find('tags[domain="jp"]:first > tag').length){
						$(xml).find('tags[domain="jp"]:first > tag').each(function(){
							tags.push({"tag":$(this).text(),"dic":U.tagDic[$(this).text()],"lock":$(this).attr('lock')=='1'?true:false});
						});
						func();
					}
				}else{
					umylistapi.getVideoArray(tid).fail(func).done(function(xml){
						if($(xml).find("title").length){
							if($(xml).find('tag_info').length){
								$(xml).find('tag_info').each(function(){
									if($(this).find('area').text()=='jp'){
										tags.push({"tag":$(this).find('tag').text(),"dic":U.tagDic[$(this).find('tag').text()],"lock":false});
									}
								});
								func();
							}
						}
					});
				}
			});
		})(function(){
			U.data[mid]["tags"]=tags;
			$("#"+tid).before(U.makeMitem(tid,mid,mylist)).remove();
			NCnl.setSt('NicoVideoData',U.data);
			$("#state").html("情報を更新しました");
		});
	},
	updateDesc:function(tid,mid,mylist){
		var U=this,tags=[];
		(function(func){
			umylistapi.getVideoArray(tid).done(function(xml){
				if($(xml).find('tag_info').length){
					$(xml).find('tag_info').each(function(){
						if($(this).find('area').text()=='jp'){
							tags.push({"tag":$(this).find('tag').text(),"dic":U.tagDic[$(this).find('tag').text()],"lock":false});
						}
					});
				}
				if($(xml).find('description').length){
					func($(xml).find('description').text());
				}else{
					umylistapi.getThumbinfo(tid).done(function(xml){
						if($(xml).find('description').length){
							func($(xml).find('description').text());
						}
					});
				}
			})
		})(function(desc){
			if(tags.length)U.data[mid]["tags"]=tags;
			U.data[mid]["desc"]=desc;
			$("#"+tid).before(U.makeMitem(tid,mid,mylist)).remove();
			NCnl.setSt('NicoVideoData',U.data);
			$("#state").html("情報を更新しました");
		});
	},
	listSet:function(){
		var U=this,html='',id,name,moviecount;
		for(var i in U.Ulist){
			id=i,name=U.Ulist[i].name,moviecount=U.Ulist[i].moviecount;
			html +=	'<li class="resItem">'+
						(umylist.mylistId?'<span class="mylistId">['+id+']</span>':'')+
						'<span class="route">└</span>'+
						'<span>'+
							'<span id="l'+id+'" class="mylistName" onclick="umylist.updateinfo('+id+',this),$(\'html,body\').scrollTop(0)">'+name+'</span>'+
							'<span id="l'+id+'len">('+moviecount+')</span>'+
						'</span>'+
					'</li>';
		}
		$('#uList').html('<ul id="uListUl">'+html+'</ul>');
	},
	mylistListSet:function(){
		var U=this,html='',mylist,id,name;
		for(var i in U.Umylistlist){
			mylistid=i,id=U.Umylistlist[i].id,name=U.Umylistlist[i].name;
			html +=	'<li class="resItem">'+
						'<span class="route">└</span>'+
						'<span>'+
							'<span id="ml'+mylistid+'" class="mylistName" onclick="umylist.officialMylistShow('+mylistid+',this,\'umylist\')">'+name+'</span>'+
							'<span id="ml'+mylistid+'len"></span>'+
						'</span>'+
					'</li>';
		}
		$('#uMylistList').html('<ul id="uMylistListUl">'+html+'</ul>');
	},
	officialSet:function(){
		$('#state').html('読み込み中');
		umylistapi.getMylistgroup(function(json){
			var html='<li class="resItem">'+
						'<span class="route">└</span>'+
						'<span>'+
							'<span id="oDef" class="mylistName" onclick="umylist.officialMylistShow(\'def\',this)">とりあえずマイリスト</span>'+
							'<span id="oDeflen"></span>'+
						'</span>'+
					'</li>';
			$.each(json.mylistgroup, function(key,value) {
				html+=	'<li class="resItem">'+
							'<span class="route">└</span>'+
							'<span>'+
								'<span id="o'+value.id+'" class="mylistName" onclick="umylist.officialMylistShow('+value.id+',this)">'+value.name+'</span>'+
								'<span id="o'+value.id+'len"></span>'+
							'</span>'+
						'</li>';
			});
			$('#officialMylist').html('<ul id="officialMylistUl">'+html+'</ul>');
			$('#state').html('読み込み完了');
		});
	},
	officialMylistShow:function(id,I,type){
		$('#state').html('読み込み中');
		var U=this;
		(function(func){
			if(!U.mylist[id]){
				(id=='def'?U.setDataDeflist():U.setDataPlaylist(id,type)).done(func);
			}else{
				func();
			}
		})(function(){
			var html='',threadid;
			for(var i=0;i<U.mylist[id].length;i++){
				html+=U.makeMitem(U.mylist[id][i]['tid'],U.mylist[id][i]['mid']);
			}
			$('#list').html('<ul>'+html+'</ul>');
			var html2=	'<select id="sort">'+
							'<option value="title_0">タイトル昇順</option>'+
							'<option value="title_1">タイトル降順</option>'+
							'<option value="date_0">投稿が新しい順</option>'+
							'<option value="date_1">投稿が古い順</option>'+
							'<option value="view_0">再生が多い順</option>'+
							'<option value="view_1">再生が少ない順</option>'+
							'<option value="comment_0">コメントが多い順</option>'+
							'<option value="comment_1">コメントが少ない順</option>'+
							'<option value="mylist_0">マイリスト登録が多い順</option>'+
							'<option value="mylist_1">マイリスト登録が少ない順</option>'+
							'<option value="sec_0">時間が長い順</option>'+
							'<option value="sec_1">時間が短い順</option>'+
						'</select>';
			if(type=='umylist'){
				var html3=	'<div class="button" onclick="umylist.listMylistRemove('+id+')">このマイリストを削除</div>'+
							'<div class="button" onclick="umylist.listMylistRename('+id+',prompt(\'新しい名前を入力してください\',\'\'))">このマイリストをリネーム</div>';
				$('#headerButton').html(html2+'<div id="sortButton" class="button" onclick="umylist.listSort(\''+id+'\',\'official\')">ソート</div>'+html3);
				$('#headerTitle').html('<a href="/mylist/'+id+'" target="_top">'+U.Umylistlist[id].name+'</a>');
			}else if(id=='def'){
				$('#headerButton').html(html2+'<div id="sortButton" class="button" onclick="umylist.listSort(\'def\',\'def\')">ソート</div>');
				$('#headerTitle').html('<a href="/my/mylist/#/home" target="_top">とりあえずマイリスト</a>');
			}else{
				$('#headerButton').html(html2+'<div id="sortButton" class="button" onclick="umylist.listSort(\''+id+'\',\'official\')">ソート</div>');
				$('#headerTitle').html('<a href="/my/mylist/#/'+id+'" target="_top">'+$('#o'+id).html()+'</a>');
			}
			$('.active').removeClass('active');
			$(I.parentNode.parentNode).addClass('active');
			$('html,body').scrollTop(0);
			$('#state').html('読み込み完了');
			NCnl.setSt('NicoVideoData',U.data);
		});
	},
	listSort:function(mylist,type){
		var U=this,A=[];
		var S=$('#sort').val().split('_');
		var D=(type=='umylist')?U.Ulist[mylist].movies:U.mylist[mylist];
		for(var i=0;i<D.length;i++){
			A.push({'tid':D[i].tid,'mid':D[i].mid});
			A[i][S[0]]=U.data[D[i].mid][S[0]];
		}
		var Sort=function(a,b){
			var A=a[S[0]];
			var B=b[S[0]];
			if(S[0]=='view' || S[0]=='mylist' || S[0]=='comment'){
				var X=function(X1){
					var X2=X1.split(','),X3='';
					for(var x=0; x<X2.length; x++)X3+=X2[x]+'';
					return X3-0;
				}
				A=X(A),B=X(B);
			}
			if(S[1]==0){
				return (A<B)?1:-1;
			}else{
				return (A>B)?1:-1;
			}
		}
		A.sort(Sort);
		var html='';
		for(var j=0;j<A.length;j++)html+=U.makeMitem(A[j].tid,A[j].mid);
		$('#list').html('<ul>'+html+'</ul>');
	},
/*******************************************************************************/
	setDataVA:function(id){
		var U=this;
		return umylistapi.getVideoArray(id,function(xml){
			$(xml).find('video_info').each(function(){
				var xml=$(this),tags=[];
				var mid=xml.find('video > id').text();
				var tid=xml.find('thread > id').text();
				var tm=xml.find('first_retrieve').text().match(/^20(\d{2})-(\d{2})-(\d{2})T(.{8})/);
				var lsec=xml.find('length_in_seconds').text()-0;
				var sec=('0'+parseInt(lsec/3600)).slice(-2)+':'+
						('0'+parseInt(lsec%3600/60)).slice(-2)+':'+
						('0'+parseInt(lsec%60)).slice(-2);
				xml.find('tag_info').each(function(){
					if($(this).find('area').text()=='jp'){
						tags.push({"tag":$(this).find('tag').text(),"dic":U.tagDic[$(this).find('tag').text()],"lock":false});
					}
				});
				var D={
					"limit":new Date().getTime()+(1000*60*60*24),
					"deleted":xml.find('deleted').text()=='0'?false:true,
					"title":xml.find('title').text(),
					"desc":xml.find('description').text(),
					"sec":sec,
					"thumb":xml.find('thumbnail_url').text(),
					"date":'20'+tm[1]+'/'+tm[2]+'/'+tm[3]+' '+tm[4],
					"view":xml.find('view_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"mylist":xml.find('mylist_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"comment":xml.find('num_res').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"tags":tags
				};
				if(!U.data[mid])U.data[mid]={};
				for(var i in D)U.data[mid][i]=D[i];
				U.data[mid][tid]={
					"threadDef":xml.find('default_thread').text()==tid?true:false,
					"communityId":xml.find('community_id').text(),
					"channelId":xml.find('channel_id').text()
				}
			});
		},function(e){
			$('#list').html('なんかエラー(時間切れかなんか)');
			$('#state').html('事故');
		});
	},
	setDataTi:function(tid,mid){
		var U=this;
		return umylistapi.getThumbinfo(tid,function(xml){
			var xml=$(xml),tags=[];
			var date = xml.find('first_retrieve').text().replace(/^(\d{4})-(\d{2})-(\d{2})T(.{8}).+$/,"$1/$2/$3 $4");
			var len=xml.find('length').text().split(':');
			var lsec=len[0]*60 + len[1]*1;
			var sec=('0'+parseInt(lsec/3600)).slice(-2)+':'+
					('0'+parseInt(lsec%3600/60)).slice(-2)+':'+
					('0'+parseInt(lsec%60)).slice(-2);
			xml.find('tags[domain="jp"]:first > tag').each(function(){
				tags.push({"tag":$(this).text(),"dic":U.tagDic[$(this).text()],"lock":$(this).attr('lock')=='1'?true:false});
			})
			var D={
				"limit":new Date().getTime()+(1000*60*60*24),
				"deleted":false,
				"title":xml.find('title').text(),
				"desc":xml.find('description').text(),
				"sec":sec,
				"thumb":xml.find('thumbnail_url').text(),
				"date":date,
				"view":xml.find('view_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
				"mylist":xml.find('mylist_counter').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
				"comment":xml.find('comment_num').text().replace(/\d(?=(\d{3})+$)/g,'$&,'),
				"tags":tags
			};
			if(!U.data[mid])U.data[mid]={};
			for(var i in D)U.data[mid][i]=D[i];
			if(!U.data[mid][tid])U.data[mid][tid]={};
			U.data[mid][tid]["threadDef"]=(xml.find('thumb_type').text()!='video'||xml.find('video_id').text().slice(0,1)!=('sm'||'nm'))?false:true;
			if(!U.data[mid][tid]["communityId"])U.data[mid][tid]["communityId"]=xml.find('community_id').text();
			if(!U.data[mid][tid]["channelId"])U.data[mid][tid]["channelId"]=xml.find('channel_id').text();
		});
	},
/********************/
	unixtimeToString:function(unix){
		var d=new Date(unix*1000);
		var month=('0'+(d.getMonth()+1)).slice(-2);
		var day=('0'+d.getDate()).slice(-2);
		var hour=('0'+d.getHours()).slice(-2);
		var min=('0'+d.getMinutes()).slice(-2);
		var sec=('0'+d.getSeconds()).slice(-2);
		return d.getFullYear()+'/'+month+'/'+day+' '+hour+':'+min+':'+sec;
	},
	setDataDeflist:function(){
		var U=this;
		U.mylist['def']=[];
		return umylistapi.getDeflist(function(json){
			$('#oDeflen').html('('+json.mylistitem.length+')');
			json.mylistitem.sort(function(a,b){
				return a.create_time-b.create_time;
			});
			$.each(json.mylistitem, function(key,value) {
				var itm=value.item_data;
				var tid=value.item_id;
				var mid=itm.video_id;
				var lsec=itm.length_seconds-0;
				var sec=('0'+parseInt(lsec/3600)).slice(-2)+':'+
						('0'+parseInt(lsec%3600/60)).slice(-2)+':'+
						('0'+parseInt(lsec%60)).slice(-2);
				var D={
					"limit":new Date().getTime()+(1000*60*60*24),
					"deleted":itm.deleted=='0'?false:true,
					"title":itm.title,
					"sec":sec,
					"thumb":itm.thumbnail_url,
					"date":U.unixtimeToString(itm.first_retrieve),
					"view":itm.view_counter.replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"mylist":itm.mylist_counter.replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"comment":itm.num_res.replace(/\d(?=(\d{3})+$)/g,'$&,'),
				};
				if(!U.data[mid])U.data[mid]={};
				for(var i in D)U.data[mid][i]=D[i];
				if(!U.data[mid][tid])U.data[mid][tid]={};
				U.data[mid][tid]["threadDef"]=itm.group_type=='default'?true:false;
				U.mylist['def'].push({"tid":tid,"mid":mid});
			});
		});
	},
	setDataPlaylist:function(id,type){
		var U=this;
		U.mylist[id]=[];
		return umylistapi.getPlaylist(id,function(json){
			var item_comparer = function(props, reverse, numeric) {
				var p = function(v) {
					return $.map(props, function(prop) {
						return v + '["' + prop.replace(/\./g, '"]["') + '"]';
					}).join("|");
				};
				return new Function('a,b', 'var x = ' + p('a') + ', y = ' + p('b') + ';'
						+ 'if (x === undefined && y !== undefined) return 1;' + 'if (x !== undefined && y === undefined) return -1;'
						+ 'if (x === undefined && y === undefined)' + 'x = a.title || a.create_time,'
						+ 'y = b.title || b.create_time;' + (numeric ? 'else x = parseFloat(x), y = parseFloat(y);' : '')
						+ (reverse ? 'return x > y ? -1 : x < y ? 1 : 0;' : 'return x < y ? -1 : x > y ? 1 : 0;'));
			};
			var itemsorts = {
				0  : item_comparer([ "create_time" ], false, true),
				1  : item_comparer([ "create_time" ], true, true),
				2  : item_comparer([ "memo" ], false),
				3  : item_comparer([ "memo" ], true),
				4  : item_comparer([ "title" ], false),
				5  : item_comparer([ "title" ], true),
				6  : item_comparer([ "first_retrieve" ], true, true),
				7  : item_comparer([ "first_retrieve" ], false, true),
				8  : item_comparer([ "view_counter" ], true, true),
				9  : item_comparer([ "view_counter" ], false, true),
				10 : item_comparer([ "item_update_time" ], true, true),
				11 : item_comparer([ "item_update_time" ], false, true),
				12 : item_comparer([ "num_res" ], true, true),
				13 : item_comparer([ "num_res" ], false, true),
				14 : item_comparer([ "mylist_counter" ], true, true),
				15 : item_comparer([ "mylist_counter" ], false, true),
				16 : item_comparer([ "length_seconds" ], true, true),
				17 : item_comparer([ "length_seconds" ], false, true),
			};
			var order=json.playlist.default_sort;
			json.items.sort(itemsorts[order]);
			$((type=='umylist'?'#ml':'#o')+id+'len').html('('+json.items.length+')')
			$.each(json.items, function(key,value) {
				var itm=value;
				var tid=itm.thread_id;
				var mid=itm.video_id;
				var lsec=itm.length_seconds-0;
				var sec=('0'+parseInt(lsec/3600)).slice(-2)+':'+
						('0'+parseInt(lsec%3600/60)).slice(-2)+':'+
						('0'+parseInt(lsec%60)).slice(-2);
				var D={
					"limit":new Date().getTime()+(1000*60*60*24),
					"deleted":itm.deleted=='0'?false:true,
					"title":itm.title,
					"desc":itm.description,
					"sec":sec,
					"thumb":itm.thumbnail_url,
					"date":U.unixtimeToString(itm.first_retrieve),
					"view":itm.view_counter.replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"mylist":itm.mylist_counter.replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"comment":itm.num_res.replace(/\d(?=(\d{3})+$)/g,'$&,'),
					"memo":itm.mylist_comment
				};
				if(!U.data[mid])U.data[mid]={};
				for(var i in D)U.data[mid][i]=D[i];
				if(!U.data[mid][tid])U.data[mid][tid]={};
				U.data[mid][tid]["threadDef"]=itm.video_id==itm.watch_id?true:false;
				U.mylist[id].push({"tid":tid,"mid":mid});
			});
		});
	}
}